import QtQuick 1.1
import org.kde.plasma.components 0.1 as PlasmaComponents
import org.kde.plasma.core 0.1 as PlasmaCore

Item {
    id: progressbar

    property int minimum: 0
    property int maximum: 100
    property int value: 0
    property color color: theme.backgroundColor
    // property double opacity: 0.2
    property string text: value + "%"
    property string when: "3 days ago"
    property string whenAlternative: "123 MB"
    property string icon: ""
    property string imageSrc: ""
    property string state: ""

    width: 200; height: 25
    clip: true

    Rectangle {
        id: highlight
        property int widthDest: progressbar.width
        width: highlight.widthDest
        // radius: 4

        Behavior on width {
            SmoothedAnimation {
                velocity: 1200
            }
        }

        anchors {
            left: parent.left
            top: parent.top
            bottom: parent.bottom
        }
        color: parent.color
        opacity: {
            if(progressbar.state === "Soon")
                return 0.35;
            return 0.2;
        }
    }    

    Image {
        id: background
       // anchors.fill: parent;
	width: parent.width - when.width - 3
	height: parent.height
        source: {
	    if(progressbar.state === "Soon")
                return progressbar.imageSrc;
	    
	}
        fillMode: Image.PreserveAspectCrop
        smooth: true
    }

    Row {
        anchors.centerIn: parent
        anchors.fill: parent
        anchors.leftMargin: 10
        anchors.rightMargin: 0

        PlasmaCore.IconItem {
            width: parent.height / 2
            height: parent.height / 2
            y: parent.height / 4
            source: {
	      if(progressbar.state != "Soon")
		    return progressbar.icon;
	    }
        }

        Rectangle {
            id:wrapperRect
            x: 10
            width: parent.width - when.width - parent.height / 2
            height:parent.height
            color: "transparent"
            clip: true
            PlasmaComponents.Label {
                x: 10
                width: parent.width - when.width - parent.height / 2
                height: wrapperRect.height
                //horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                id: textContainer
                text: { 
		  if(progressbar.state != "Soon")
		    return progressbar.text;
		}
            }
        }

        Rectangle {
            id: whenRect
            width: 70;
            height: parent.height
            color: "transparent"

            Rectangle {
                y: 0
                width: whenRect.width
                height:whenRect.height
                color: progressbar.color
                opacity: {
                    return highlight.opacity;
                }
            }


            PlasmaComponents.Label {
                id: when
                text: progressbar.when
                style: Text.Raised
                width: whenRect.width
                height: parent.height
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }

        PlasmaCore.Theme {
            id: theme
        }
    }
}
